--------------------------------------------------------------[[ Wilmatron, GDI Final Mission 15EA ]]
-- [[ Pre-World Build ]]

Camera.Position = DefaultCameraPosition.CenterPosition
Test = { FTank }

--Declare initial GDI reinforcements
InitialGDIForcesA = { "mcv" }
InitialGDIForcesB = { "mtnk" }

--Declare all NOD SAM sites
NODSams = { Sam01, Sam02, Sam03, Sam04, Sam05 }

--Declare all NOD main production facilities
NODMainBuildings = { NODBarracks1, NODBarracks2, NODFactory1, NODFactory2, NODConYard1, NODConYard2 }

--Declare NOD attack forces (for wave attacks)
NODAttackWave1 = { barracks = NODBarracks2, types = { "e1", "e1", "e1", "e1", "e3", "e3" }, factory = { }, vehicles = { } }
NODAttackWave2 = { barracks = NODBarracks2, types = { "e4", "e4" }, factory = NODFactory2, vehicles = { "bggy" } }
NODAttackWave3 = { barracks = NODBarracks1, types = { "e3", "e3", "e4", "e4" }, factory = { }, vehicles = { } }
NODAttackWave4 = { barracks = NODBarracks1, types = { "e3", "e3" }, factory = NODFactory1, vehicles = { "ltnk" } }
NODAttackWave5 = { barracks = NODBarracks1, types = { "e1", "e1", "e1" }, factory = NODFactory1, vehicles = { "arty" } }

--Declare NOD attack routes (for wave attacks)
NODAttackRoute1 = { waypoint0.Location, waypoint1.Location, waypoint2.Location, waypoint3.Location, waypoint4.Location }
NODAttackRoute2 = { waypoint0.Location, waypoint1.Location, waypoint10.Location}
NODAttackRoute3 = { waypoint1.Location, waypoint10.Location}
NODAttackRoute4 = { waypoint1.Location, waypoint2.Location, waypoint3.Location, waypoint4.Location }

NODAttackingForces = {                                                                              --Declare NOD random attacking forces
		{ barracks = NODBarracks1, types = { "e1" }, factory = { }, vehicles = { } }
}

NODAttackRoutes = {                                                                                 --Declare NOD random attack routes
    { waypoint1.Location, waypoint10.Location},
    { waypoint1.Location, waypoint2.Location, waypoint3.Location, waypoint4.Location }
  }

BuildFromFactory = function(factory, units, action)                                                 --Declare factory build function
	if factory.IsDead or factory.Owner ~= enemy then
		return
	end

	if not factory.Build(units, action) then
		Trigger.AfterDelay(DateTime.Seconds(2), function()
			Build(factory, units, action)
		end)
	end
end

BuildFromBarracks = function(barracks, units, action)                                               --Declare barracks build function
	if barracks.IsDead or barracks.Owner ~= enemy then
		return
	end
  
  if not barracks.Build(units, action) then
		Trigger.AfterDelay(DateTime.Seconds(2), function()
			Build(barracks, units, action)
		end)
	end
end

--
--Declare Functions
--
SendInitialGDIForcesA = function()                                                                  -- Send initial GDI reinforcements, MCV
	Media.PlaySpeechNotification(player, "Reinforce")
	Reinforcements.Reinforce(player, InitialGDIForcesA, { InitForces.Location, waypoint13.Location }, 5)
end
SendInitialGDIForcesB = function()                                                                  -- Send initial GDI reinforcements, M.Tank
  Media.PlaySpeechNotification(player, "Reinforce")
	Reinforcements.Reinforce(player, InitialGDIForcesB, { InitForces.Location, waypoint13.Location }, 15)
end


FlameTankHarass = function()                                                                        -- Harassing flame tank and attacking strategy
  local InitialNODFlameTank = FTank
  InitialNODFlameTank.Wait(150)
  InitialNODFlameTank.AttackMove(waypoint4.Location)
  InitialNODFlameTank.Wait(100)
  InitialNODFlameTank.AttackMove(waypoint13.Location)
end

NODTankPatrol = function()                                                                          -- NOD Tank Patrol units, plus patrol routes
  local NODTankPatrolUnit1 = LTank1
  local NODTankPatrolUnit2 = LTank2
  local NODTankPath = { waypoint1.Location, waypoint2.Location, waypoint8.Location, waypoint2.Location, waypoint1.Location, waypoint5.Location, waypoint9.Location, waypoint5.Location}
  NODTankPatrolUnit1.Wait(125)
  NODTankPatrolUnit1.Patrol(NODTankPath, true, 100)
  NODTankPatrolUnit2.Wait(125)
  NODTankPatrolUnit2.Patrol(NODTankPath, true, 100)
end

RebuildWave1 = function()                                                                           -- Should all of NOD Wave 1 attacking force be destroyed, rebuild them
  local production = NODAttackWave1
  BuildFromBarracks(production.barracks, production.types, function(units)
  end)
end
RebuildWave3 = function()                                                                           -- Should all of NOD Wave 3 attacking force be destroyed, rebuild them
  local production = NODAttackWave3
  BuildFromBarracks(production.barracks, production.types, function(units)
  end)
end
AttackPlayerWave1 = function()                                                                      -- NOD Wave 1 attacking force, plus attacking strategy - update
  local production = NODAttackWave1 
	local path = NODAttackRoute1
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
  --Trigger.OnAllKilled(units, RebuildWave1)
	end)
end
AttackPlayerWave2 = function()                                                                      -- NOD Wave 2 attacking force, plus attacking strategy
  local production = NODAttackWave2 
	local path = NODAttackRoute2
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
end
AttackPlayerWave3 = function()                                                                      -- NOD Wave 3 attacking force, plus attacking strategy
 local production = NODAttackWave3 
	local path = NODAttackRoute3
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
  --Trigger.OnAllKilled(units, RebuildWave3)
	end)
end 

AttackPlayerWave4 = function()                                                                      -- NOD Wave 4 attacking force, plus attacking strategy
  local production = NODAttackWave4 
	local path = NODAttackRoute4
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
end
AttackPlayerWave5 = function()                                                                      -- NOD Wave 5 attacking force, plus attacking strategy
  local production = NODAttackWave5 
	local path = NODAttackRoute4
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false, 100)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
end
AttackPlayerRandom = function()                                                                     -- NOD Random attacking force, plus attacking strategy, loop every 2 minutes
  local production = Utils.Random(NODAttackingForces) 
	local path = Utils.Random(NODAttackRoutes)
	BuildFromFactory(production.factory, production.vehicles, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  BuildFromBarracks(production.barracks, production.types, function(units)
		Utils.Do(units, function(unit)
			if unit.Owner ~= enemy then return end
			unit.Patrol(path, false)
			Trigger.OnIdle(unit, unit.Hunt)
		end)
	end)
  Trigger.AfterDelay(DateTime.Seconds(120), AttackPlayerRandom)
end

WorldLoaded = function()                                                                            -- When the world has loaded perform the following within...
  
	player = Player.GetPlayer("GDI")                                                                  -- Define player as GDI forces
	enemy = Player.GetPlayer("Nod")                                                                   -- Define enemy as NOD forces
	villagers = Player.GetPlayer("Villagers")                                                         -- Define villagers as villagers
    
	Trigger.OnObjectiveAdded(player, function(p, id)                                                  -- When adding an objective display message
		Media.DisplayMessage(p.GetObjectiveDescription(id), "New " .. string.lower(p.GetObjectiveType(id)) .. " objective")
	end)
	Trigger.OnObjectiveCompleted(player, function(p, id)                                              -- When completing an objective display message
		Media.DisplayMessage(p.GetObjectiveDescription(id), "Objective completed")
	end)
	Trigger.OnObjectiveFailed(player, function(p, id)                                                 -- When failing an objective display message
		Media.DisplayMessage(p.GetObjectiveDescription(id), "Objective failed")
	end)

	
  Trigger.OnPlayerWon(player, function()                                                            -- When player wins the mission play a speech notification "Win"
		Media.PlaySpeechNotification(player, "Win")
	end)

	Trigger.OnPlayerLost(player, function()                                                           -- When player loses the mission play a speech notification "Lose"
		Media.PlaySpeechNotification(player, "Lose")
	end)
  
  
  
  GDIObjective1 = player.AddPrimaryObjective("Destroy the NOD stronghold.")                         -- Create Primary Objective for the player
  GDIObjective2 = player.AddSecondaryObjective("Destroy the SAM sites to receive air support.")     -- Create Secondary Objective for the player
  NodObjective1 = enemy.AddPrimaryObjective("Eliminate all GDI forces.")                            -- Create Primary Objective for the enemy
  
  SendInitialGDIForcesA()                                                                           -- Spawn GDI MCV to map
  Trigger.AfterDelay(DateTime.Seconds(6), SendInitialGDIForcesB)                                    -- Spawn GDI Med Tank to map, 6 seconds after the MVC unit arrives
  FlameTankHarass()                                                                                 -- Harass GDI with flame tank
  NODTankPatrol()                                                                                   -- Initiate NOD Tank Patrol
  
  Trigger.AfterDelay(DateTime.Seconds(1), AttackPlayerWave1)                                        -- Build a new team to attack GDI after 90 seconds of game time, NOD Wave 1
  Trigger.AfterDelay(DateTime.Seconds(2), AttackPlayerWave2)                                        -- Build a new team to attack GDI after 95 seconds of game time, NOD Wave 2
  Trigger.AfterDelay(DateTime.Seconds(210), AttackPlayerWave3)                                      -- Build a new team to attack GDI after 150 seconds of game time, NOD Wave 3
  Trigger.AfterDelay(DateTime.Seconds(270), AttackPlayerWave4)                                      -- Build a new team to attack GDI after 155 seconds of game time, NOD Wave 4
  Trigger.AfterDelay(DateTime.Seconds(330), AttackPlayerWave5)                                      -- Build a new team to attack GDI after 180 seconds of game time, NOD Wave 5
  Trigger.AfterDelay(DateTime.Seconds(450), AttackPlayerRandom)                                     -- Build a random new team to attack GDI after X seconds of game time
  
  Trigger.OnAllKilled(NODSams, function()                                                           -- When all NOD SAM Sites are destroyed, unlock airstrikes for GDI
		player.MarkCompletedObjective(GDIObjective2)
    Media.PlaySpeechNotification(player, "AirstrikeReady")
		Actor.Create("airstrike.proxy", true, { Owner = player })
	end)
  Trigger.OnDamaged(Temple, function()                                                              -- If the Temple of NOD is attacked, have NOD launch a nuclear warhead
    Media.PlaySpeechNotification(player, "NuclearWeaponLaunched")
  end)
  Trigger.OnAllKilledOrCaptured(NODMainBuildings, function()                                        -- If all NOD main buildings have been destroyed send all remaining NOD units to hunt
    local list = enemy.GetGroundAttackers()
    Utils.Do(list, function(unit)
		IdleHunt(unit)
    end)
  end)
  IdleHunt = function(unit)
    if not unit.IsDead then
      Trigger.OnIdle(unit, unit.Hunt)
    end
  end
Utils.Do(Map.NamedActors, function(actor)                                                           -- If enemy structure is damaged beyond 50% of max health then repair building
  if actor.Owner == enemy and actor.HasProperty("StartBuildingRepairs") then
    Trigger.OnDamaged(actor, function(building)
      if building.Owner == enemy and building.Health < 0.5 * building.MaxHealth then
      building.StartBuildingRepairs()
				end
    end)
  end
end)
end
Tick = function()                                                                                   -- Continually check if all GDI or NOD units destroyed, then update mission objective 1
	if DateTime.GameTime > 2 then
		if player.HasNoRequiredUnits() then
			enemy.MarkCompletedObjective(NodObjective1)
		end
		if enemy.HasNoRequiredUnits() then
			player.MarkCompletedObjective(GDIObjective1)
		end
	end
end